import * as std from "tstl";
import { ICollection } from "../basic/ICollection";
import { CollectionEvent } from "../basic/CollectionEvent";
export declare class ArrayCollection<T> extends std.Vector<T> implements ICollection<T, std.Vector<T>, std.Vector.Iterator<T>, std.Vector.ReverseIterator<T>> {
    /**
     * @hidden
     */
    private dispatcher_;
    clear(): void;
    /**
     * @inheritdoc
     */
    push(...items: T[]): number;
    /**
     * @inheritdoc
     */
    push_back(val: T): void;
    /**
     * @hidden
     */
    protected _Insert_by_range<U extends T, InputIterator extends std.IForwardIterator<U, InputIterator>>(pos: std.Vector.Iterator<T>, first: InputIterator, last: InputIterator): std.Vector.Iterator<T>;
    /**
     * @inheritdoc
     */
    pop_back(): void;
    /**
     * @hidden
     */
    protected _Erase_by_range(first: std.Vector.Iterator<T>, last: std.Vector.Iterator<T>): std.Vector.Iterator<T>;
    /**
     * @inheritDoc
     */
    set(index: number, val: T): void;
    /**
     * @inheritdoc
     */
    refresh(): void;
    /**
     * @inheritdoc
     */
    refresh(it: std.Vector.Iterator<T>): void;
    /**
     * @inheritdoc
     */
    refresh(first: std.Vector.Iterator<T>, last: std.Vector.Iterator<T>): void;
    /**
     * @inheritdoc
     */
    dispatchEvent(event: ArrayCollection.Event<T>): void;
    /**
     * @hidden
     */
    private _Notify_insert;
    /**
     * @hidden
     */
    private _Notify_erase;
    /**
     * @inheritdoc
     */
    hasEventListener(type: CollectionEvent.Type): boolean;
    /**
     * @inheritdoc
     */
    addEventListener(type: CollectionEvent.Type, listener: ArrayCollection.Listener<T>): void;
    /**
     * @inheritdoc
     */
    removeEventListener(type: CollectionEvent.Type, listener: ArrayCollection.Listener<T>): void;
}
export declare namespace ArrayCollection {
    type Event<T> = CollectionEvent<T, std.Vector<T>, std.Vector.Iterator<T>, std.Vector.ReverseIterator<T>>;
    type Listener<T> = CollectionEvent.Listener<T, std.Vector<T>, std.Vector.Iterator<T>, std.Vector.ReverseIterator<T>>;
    const Event: typeof CollectionEvent;
    export import Iterator = std.Vector.Iterator;
    export import ReverseIterator = std.Vector.ReverseIterator;
}
//# sourceMappingURL=VectorCollection.d.ts.map