import * as std from "tstl";
import { ICollection } from "../basic/ICollection";
import { CollectionEvent } from "../basic/CollectionEvent";
import "./internal";
export declare class HashMapCollection<Key, T> extends std.HashMap<Key, T> implements ICollection<std.Entry<Key, T>, std.HashMap<Key, T>, std.HashMap.Iterator<Key, T>, std.HashMap.ReverseIterator<Key, T>> {
    /**
     * @hidden
     */
    private dispatcher_;
    clear(): void;
    /**
     * @hidden
     */
    protected _Handle_insert(first: std.HashMap.Iterator<Key, T>, last: std.HashMap.Iterator<Key, T>): void;
    /**
     * @hidden
     */
    protected _Handle_erase(first: std.HashMap.Iterator<Key, T>, last: std.HashMap.Iterator<Key, T>): void;
    /**
     * @inheritDoc
     */
    dispatchEvent(event: HashMapCollection.Event<Key, T>): void;
    /**
     * @inheritDoc
     */
    refresh(): void;
    /**
     * @inheritDoc
     */
    refresh(it: std.HashMap.Iterator<Key, T>): void;
    /**
     * @inheritDoc
     */
    refresh(first: std.HashMap.Iterator<Key, T>, last: std.HashMap.Iterator<Key, T>): void;
    /**
     * @inheritDoc
     */
    hasEventListener(type: CollectionEvent.Type): boolean;
    /**
     * @inheritDoc
     */
    addEventListener(type: CollectionEvent.Type, listener: HashMapCollection.Listener<Key, T>): void;
    /**
     * @inheritDoc
     */
    removeEventListener(type: CollectionEvent.Type, listener: HashMapCollection.Listener<Key, T>): void;
}
export declare namespace HashMapCollection {
    type Event<Key, T> = CollectionEvent<std.Entry<Key, T>, std.HashMap<Key, T>, std.HashMap.Iterator<Key, T>, std.HashMap.ReverseIterator<Key, T>>;
    type Listener<Key, T> = CollectionEvent.Listener<std.Entry<Key, T>, std.HashMap<Key, T>, std.HashMap.Iterator<Key, T>, std.HashMap.ReverseIterator<Key, T>>;
    const Event: typeof CollectionEvent;
    export import Iterator = std.HashMap.Iterator;
    export import ReverseIterator = std.HashMap.ReverseIterator;
}
//# sourceMappingURL=HashMapCollection.d.ts.map