import * as std from "tstl";
import { ICollection } from "../basic/ICollection";
import { CollectionEvent } from "../basic/CollectionEvent";
import "./internal";
export declare class HashMultiMapCollection<Key, T> extends std.HashMultiMap<Key, T> implements ICollection<std.Entry<Key, T>, std.HashMultiMap<Key, T>, std.HashMultiMap.Iterator<Key, T>, std.HashMultiMap.ReverseIterator<Key, T>> {
    /**
     * @hidden
     */
    private dispatcher_;
    clear(): void;
    /**
     * @hidden
     */
    protected _Handle_insert(first: std.HashMultiMap.Iterator<Key, T>, last: std.HashMultiMap.Iterator<Key, T>): void;
    /**
     * @hidden
     */
    protected _Handle_erase(first: std.HashMultiMap.Iterator<Key, T>, last: std.HashMultiMap.Iterator<Key, T>): void;
    /**
     * @inheritDoc
     */
    dispatchEvent(event: HashMultiMapCollection.Event<Key, T>): void;
    /**
     * @inheritDoc
     */
    refresh(): void;
    /**
     * @inheritDoc
     */
    refresh(it: std.HashMultiMap.Iterator<Key, T>): void;
    /**
     * @inheritDoc
     */
    refresh(first: std.HashMultiMap.Iterator<Key, T>, last: std.HashMultiMap.Iterator<Key, T>): void;
    /**
     * @inheritDoc
     */
    hasEventListener(type: CollectionEvent.Type): boolean;
    /**
     * @inheritDoc
     */
    addEventListener(type: CollectionEvent.Type, listener: HashMultiMapCollection.Listener<Key, T>): void;
    /**
     * @inheritDoc
     */
    removeEventListener(type: CollectionEvent.Type, listener: HashMultiMapCollection.Listener<Key, T>): void;
}
export declare namespace HashMultiMapCollection {
    type Event<Key, T> = CollectionEvent<std.Entry<Key, T>, std.HashMultiMap<Key, T>, std.HashMultiMap.Iterator<Key, T>, std.HashMultiMap.ReverseIterator<Key, T>>;
    type Listener<Key, T> = CollectionEvent.Listener<std.Entry<Key, T>, std.HashMultiMap<Key, T>, std.HashMultiMap.Iterator<Key, T>, std.HashMultiMap.ReverseIterator<Key, T>>;
    const Event: typeof CollectionEvent;
    export import Iterator = std.HashMultiMap.Iterator;
    export import ReverseIterator = std.HashMultiMap.ReverseIterator;
}
//# sourceMappingURL=HashMultiMapCollection.d.ts.map