import * as std from "tstl";
import { ICollection } from "../basic/ICollection";
import { CollectionEvent } from "../basic/CollectionEvent";
import "./internal";
export declare class TreeMapCollection<Key, T> extends std.TreeMap<Key, T> implements ICollection<std.Entry<Key, T>, std.TreeMap<Key, T>, std.TreeMap.Iterator<Key, T>, std.TreeMap.ReverseIterator<Key, T>> {
    /**
     * @hidden
     */
    private dispatcher_;
    clear(): void;
    /**
     * @hidden
     */
    protected _Handle_insert(first: std.TreeMap.Iterator<Key, T>, last: std.TreeMap.Iterator<Key, T>): void;
    /**
     * @hidden
     */
    protected _Handle_erase(first: std.TreeMap.Iterator<Key, T>, last: std.TreeMap.Iterator<Key, T>): void;
    /**
     * @inheritDoc
     */
    dispatchEvent(event: TreeMapCollection.Event<Key, T>): void;
    /**
     * @inheritDoc
     */
    refresh(): void;
    /**
     * @inheritDoc
     */
    refresh(it: std.TreeMap.Iterator<Key, T>): void;
    /**
     * @inheritDoc
     */
    refresh(first: std.TreeMap.Iterator<Key, T>, last: std.TreeMap.Iterator<Key, T>): void;
    /**
     * @inheritDoc
     */
    hasEventListener(type: CollectionEvent.Type): boolean;
    /**
     * @inheritDoc
     */
    addEventListener(type: CollectionEvent.Type, listener: TreeMapCollection.Listener<Key, T>): void;
    /**
     * @inheritDoc
     */
    removeEventListener(type: CollectionEvent.Type, listener: TreeMapCollection.Listener<Key, T>): void;
}
export declare namespace TreeMapCollection {
    type Event<Key, T> = CollectionEvent<std.Entry<Key, T>, std.TreeMap<Key, T>, std.TreeMap.Iterator<Key, T>, std.TreeMap.ReverseIterator<Key, T>>;
    type Listener<Key, T> = CollectionEvent.Listener<std.Entry<Key, T>, std.TreeMap<Key, T>, std.TreeMap.Iterator<Key, T>, std.TreeMap.ReverseIterator<Key, T>>;
    const Event: typeof CollectionEvent;
    export import Iterator = std.TreeMap.Iterator;
    export import ReverseIterator = std.TreeMap.ReverseIterator;
}
//# sourceMappingURL=TreeMapCollection.d.ts.map