import * as std from "tstl";
import { ICollection } from "../basic/ICollection";
import { CollectionEvent } from "../basic/CollectionEvent";
import "./internal";
export declare class TreeMultiMapCollection<Key, T> extends std.TreeMultiMap<Key, T> implements ICollection<std.Entry<Key, T>, std.TreeMultiMap<Key, T>, std.TreeMultiMap.Iterator<Key, T>, std.TreeMultiMap.ReverseIterator<Key, T>> {
    /**
     * @hidden
     */
    private dispatcher_;
    clear(): void;
    /**
     * @hidden
     */
    protected _Handle_insert(first: std.TreeMultiMap.Iterator<Key, T>, last: std.TreeMultiMap.Iterator<Key, T>): void;
    /**
     * @hidden
     */
    protected _Handle_erase(first: std.TreeMultiMap.Iterator<Key, T>, last: std.TreeMultiMap.Iterator<Key, T>): void;
    /**
     * @inheritDoc
     */
    dispatchEvent(event: TreeMultiMapCollection.Event<Key, T>): void;
    /**
     * @inheritDoc
     */
    refresh(): void;
    /**
     * @inheritDoc
     */
    refresh(it: std.TreeMultiMap.Iterator<Key, T>): void;
    /**
     * @inheritDoc
     */
    refresh(first: std.TreeMultiMap.Iterator<Key, T>, last: std.TreeMultiMap.Iterator<Key, T>): void;
    /**
     * @inheritDoc
     */
    hasEventListener(type: CollectionEvent.Type): boolean;
    /**
     * @inheritDoc
     */
    addEventListener(type: CollectionEvent.Type, listener: TreeMultiMapCollection.Listener<Key, T>): void;
    /**
     * @inheritDoc
     */
    removeEventListener(type: CollectionEvent.Type, listener: TreeMultiMapCollection.Listener<Key, T>): void;
}
export declare namespace TreeMultiMapCollection {
    type Event<Key, T> = CollectionEvent<std.Entry<Key, T>, std.TreeMultiMap<Key, T>, std.TreeMultiMap.Iterator<Key, T>, std.TreeMultiMap.ReverseIterator<Key, T>>;
    type Listener<Key, T> = CollectionEvent.Listener<std.Entry<Key, T>, std.TreeMultiMap<Key, T>, std.TreeMultiMap.Iterator<Key, T>, std.TreeMultiMap.ReverseIterator<Key, T>>;
    const Event: typeof CollectionEvent;
    export import Iterator = std.TreeMultiMap.Iterator;
    export import ReverseIterator = std.TreeMultiMap.ReverseIterator;
}
//# sourceMappingURL=TreeMultiMapCollection.d.ts.map