import * as std from "tstl";
import { ICollection } from "../basic/ICollection";
import { CollectionEvent } from "../basic/CollectionEvent";
export declare class HashSetCollection<T> extends std.HashSet<T> implements ICollection<T, std.HashSet<T>, std.HashSet.Iterator<T>, std.HashSet.ReverseIterator<T>> {
    /**
     * @hidden
     */
    private dispatcher_;
    clear(): void;
    /**
     * @hidden
     */
    protected _Handle_insert(first: std.HashSet.Iterator<T>, last: std.HashSet.Iterator<T>): void;
    /**
     * @hidden
     */
    protected _Handle_erase(first: std.HashSet.Iterator<T>, last: std.HashSet.Iterator<T>): void;
    /**
     * @inheritDoc
     */
    dispatchEvent(event: HashSetCollection.Event<T>): void;
    /**
     * @inheritDoc
     */
    refresh(): void;
    /**
     * @inheritDoc
     */
    refresh(it: std.HashSet.Iterator<T>): void;
    /**
     * @inheritDoc
     */
    refresh(first: std.HashSet.Iterator<T>, last: std.HashSet.Iterator<T>): void;
    /**
     * @inheritDoc
     */
    hasEventListener(type: CollectionEvent.Type): boolean;
    /**
     * @inheritDoc
     */
    addEventListener(type: CollectionEvent.Type, listener: HashSetCollection.Listener<T>): void;
    /**
     * @inheritDoc
     */
    removeEventListener(type: CollectionEvent.Type, listener: HashSetCollection.Listener<T>): void;
}
export declare namespace HashSetCollection {
    type Event<T> = CollectionEvent<T, std.HashSet<T>, std.HashSet.Iterator<T>, std.HashSet.ReverseIterator<T>>;
    type Listener<T> = CollectionEvent.Listener<T, std.HashSet<T>, std.HashSet.Iterator<T>, std.HashSet.ReverseIterator<T>>;
    const Event: typeof CollectionEvent;
    export import Iterator = std.HashSet.Iterator;
    export import ReverseIterator = std.HashSet.ReverseIterator;
}
//# sourceMappingURL=HashSetCollection.d.ts.map