import * as std from "tstl";
import { ICollection } from "../basic/ICollection";
import { CollectionEvent } from "../basic/CollectionEvent";
export declare class TreeMultiSetCollection<T> extends std.TreeMultiSet<T> implements ICollection<T, std.TreeMultiSet<T>, std.TreeMultiSet.Iterator<T>, std.TreeMultiSet.ReverseIterator<T>> {
    /**
     * @hidden
     */
    private dispatcher_;
    clear(): void;
    /**
     * @hidden
     */
    protected _Handle_insert(first: std.TreeMultiSet.Iterator<T>, last: std.TreeMultiSet.Iterator<T>): void;
    /**
     * @hidden
     */
    protected _Handle_erase(first: std.TreeMultiSet.Iterator<T>, last: std.TreeMultiSet.Iterator<T>): void;
    /**
     * @inheritDoc
     */
    dispatchEvent(event: TreeMultiSetCollection.Event<T>): void;
    /**
     * @inheritDoc
     */
    refresh(): void;
    /**
     * @inheritDoc
     */
    refresh(it: std.TreeMultiSet.Iterator<T>): void;
    /**
     * @inheritDoc
     */
    refresh(first: std.TreeMultiSet.Iterator<T>, last: std.TreeMultiSet.Iterator<T>): void;
    /**
     * @inheritDoc
     */
    hasEventListener(type: CollectionEvent.Type): boolean;
    /**
     * @inheritDoc
     */
    addEventListener(type: CollectionEvent.Type, listener: TreeMultiSetCollection.Listener<T>): void;
    /**
     * @inheritDoc
     */
    removeEventListener(type: CollectionEvent.Type, listener: TreeMultiSetCollection.Listener<T>): void;
}
export declare namespace TreeMultiSetCollection {
    type Event<T> = CollectionEvent<T, std.TreeMultiSet<T>, std.TreeMultiSet.Iterator<T>, std.TreeMultiSet.ReverseIterator<T>>;
    type Listener<T> = CollectionEvent.Listener<T, std.TreeMultiSet<T>, std.TreeMultiSet.Iterator<T>, std.TreeMultiSet.ReverseIterator<T>>;
    const Event: typeof CollectionEvent;
    export import Iterator = std.TreeMultiSet.Iterator;
    export import ReverseIterator = std.TreeMultiSet.ReverseIterator;
}
//# sourceMappingURL=TreeMultiSetCollection.d.ts.map