import * as std from "tstl";
import { ICollection } from "../basic/ICollection";
import { CollectionEvent } from "../basic/CollectionEvent";
export declare class TreeSetCollection<T> extends std.TreeSet<T> implements ICollection<T, std.TreeSet<T>, std.TreeSet.Iterator<T>, std.TreeSet.ReverseIterator<T>> {
    /**
     * @hidden
     */
    private dispatcher_;
    clear(): void;
    /**
     * @hidden
     */
    protected _Handle_insert(first: std.TreeSet.Iterator<T>, last: std.TreeSet.Iterator<T>): void;
    /**
     * @hidden
     */
    protected _Handle_erase(first: std.TreeSet.Iterator<T>, last: std.TreeSet.Iterator<T>): void;
    /**
     * @inheritDoc
     */
    dispatchEvent(event: TreeSetCollection.Event<T>): void;
    /**
     * @inheritDoc
     */
    refresh(): void;
    /**
     * @inheritDoc
     */
    refresh(it: std.TreeSet.Iterator<T>): void;
    /**
     * @inheritDoc
     */
    refresh(first: std.TreeSet.Iterator<T>, last: std.TreeSet.Iterator<T>): void;
    /**
     * @inheritDoc
     */
    hasEventListener(type: CollectionEvent.Type): boolean;
    /**
     * @inheritDoc
     */
    addEventListener(type: CollectionEvent.Type, listener: TreeSetCollection.Listener<T>): void;
    /**
     * @inheritDoc
     */
    removeEventListener(type: CollectionEvent.Type, listener: TreeSetCollection.Listener<T>): void;
}
export declare namespace TreeSetCollection {
    type Event<T> = CollectionEvent<T, std.TreeSet<T>, std.TreeSet.Iterator<T>, std.TreeSet.ReverseIterator<T>>;
    type Listener<T> = CollectionEvent.Listener<T, std.TreeSet<T>, std.TreeSet.Iterator<T>, std.TreeSet.ReverseIterator<T>>;
    const Event: typeof CollectionEvent;
    export import Iterator = std.TreeSet.Iterator;
    export import ReverseIterator = std.TreeSet.ReverseIterator;
}
//# sourceMappingURL=TreeSetCollection.d.ts.map